<?php


namespace Service;

use Util\InstanceProvider;
use Zeedhi\Framework\Session\Session;
use \Util\Utilities;
use \Doctrine\ORM\EntityManager;
use Repository\Classification as ClassificationRepository;

class Classification
{
    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var Utilities
     */
    private $environment;
    /**
     * @var Repository\Classification
     */
    private $classificationRepository;

    public function __construct(EntityManager $entityManager, Utilities $environment, ClassificationRepository $classificationRepository)
    {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->classificationRepository = $classificationRepository;
    }

    public function findClassificationsTaskTracking()
    {
        $organizationId = $this->environment->getCurrentOrganizationId();
        $classifications = $this->classificationRepository->findClassificationsTaskTracking($organizationId);
        foreach ($classifications['data'] as &$classification) {
            $classification['ALLOWED_PROJECT_STATUS'] = Utilities::setSelectMultiInQuery($classification['ALLOWED_PROJECT_STATUS']);
            $classification['ALLOWED_PROJECT_TYPE'] = Utilities::setSelectMultiInQuery($classification['ALLOWED_PROJECT_TYPE']);
            $classification['NOT_ALLOWED_PROJECT_STATUS'] = Utilities::setSelectMultiInQuery($classification['NOT_ALLOWED_PROJECT_STATUS']);
            $classification['NOT_ALLOWED_PROJECT_TYPE'] = Utilities::setSelectMultiInQuery($classification['NOT_ALLOWED_PROJECT_TYPE']);
            $classification['NRPERFILACESSO'] = Utilities::setSelectMultiInQuery($classification['NRPERFILACESSO']);
        }
        return $classifications;
    }

}