<?php

namespace Service;

use Doctrine\ORM\EntityManager;
use Exception;
use Service\Integration\IntegrationSM;
use Teknisa\Libs\Util\Masks\Picture;
use Teknisa\Model\Teknisa\Entities\CpCall;
use Teknisa\Model\Teknisa\Entities\Orcasolicita;
use Teknisa\Model\Teknisa\Entities\Parcsoliserv;
use Teknisa\Model\Teknisa\Entities\Tarefa;
use Util\Instance\Repository;
use Util\InstanceProvider;
use Util\Utilities;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource;
use Zeedhi\DevOps\Util\Utilities as DevOpsUtilities;
use Zeedhi\Framework\ORM\DateTime;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use Util\Messages;

class ValoresOrcaCli
{
    /**
     * @var EntityManager
     */
    public $entityManager;
    /**
     * @var Utilities
     */
    public $environment;
    /**
     * @var int|mixed
     */
    private $nrorg;

    public function __construct()
    {
        $this->entityManager  = InstanceProvider::getEntityManager();
        $this->environment    = InstanceProvider::getEnvironment();

        $this->nrorg = $this->environment->getCurrentOrganizationId();
    }

    public function saveNrParcelaValoresOrcaClie($rows)
    {
        $connection = InstanceProvider::getEntityManager()->getConnection();
        try {
            $connection->beginTransaction();
            foreach ($rows as $row) {
                $qtparccust = empty($row['QTPARCCUST']) ? null : $row['QTPARCCUST'];
                $cdcliente = $row['CDCLIENTE'];
                InstanceProvider::getRepository()->getValoresOrcaCliLocal()->updateNrParcelaCliente($qtparccust, $cdcliente);
            }
            $connection->commit();
        } catch (\Exception $e) {
            try {
                $connection->rollBack();
                throw $e;
            } catch (\Exception $e2) {}
            throw $e;
        }
    }

    public function qryVigencia($cdcliente)
    {
        return InstanceProvider::getRepository()->getValoresOrcaCliLocal()->qryVigencia($cdcliente);
    }

    public function qryItemOrca($cdcliente, $dtinivaitorc)
    {
        $qryItemOrca = InstanceProvider::getRepository()->getValoresOrcaCliLocal();
        return $qryItemOrca->qryItemOrca($cdcliente, $dtinivaitorc);
    }

    public function qryDelItemOrca($rows)
    {
        $connection = InstanceProvider::getEntityManager()->getConnection();
        try {
            $connection->beginTransaction();
            foreach ($rows as $row) {
                InstanceProvider::getRepository()->getValoresOrcaCliLocal()->qryDelItemOrca($row['CDCLIENTE']);
            }
            $connection->commit();
        } catch (\Exception $e) {
            try {
                $connection->rollBack();
                throw $e;
            } catch (\Exception $e2) {}
            throw $e;
        }
    }

    public function saveValoresOrcaCliTab($dtinivaitorc, $cdcliente, $itens)
    {
        $connection = InstanceProvider::getEntityManager()->getConnection();
        try {
            $connection->beginTransaction();
            foreach ($itens as $item) {
                $vritorcaclie = empty($item['VRITORCACLIE']) ? null : $item['VRITORCACLIE'];
                if ($vritorcaclie == null) {
                    InstanceProvider::getRepository()->getValoresOrcaCliLocal()->qryDelValorItemOrca($cdcliente, $item['CDITORCAPROD'], $dtinivaitorc);
                } elseif ($item['CDCLIENTE'] == null) {
                    InstanceProvider::getRepository()->getValoresOrcaCliLocal()->insertItemOrcaClie($vritorcaclie, $cdcliente, $item['CDITORCAPROD'], $dtinivaitorc);
                } else {
                    InstanceProvider::getRepository()->getValoresOrcaCliLocal()->updateItemOrcaClie($vritorcaclie, $cdcliente, $item['CDITORCAPROD'], $dtinivaitorc);
                }
            }
            $connection->commit();
        } catch (\Exception $e) {
            try {
                $connection->rollBack();
                throw $e;
            } catch (\Exception $e2) {}
            throw $e;
        }
    }
}
